/*
Copyright © 2023 Philipp Wolfer <phw@uploadedlobster.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package maloja

type GetListensResult struct {
	Status     string     `json:"status"`
	Listens    []Listen   `json:"list"`
	Pagination Pagination `json:"pagination"`
}

type Listen struct {
	ListenedAt int64 `json:"time"`
	Duration   int64 `json:"duration"`
	// Maloja sets Origin to the name of the API key
	// prefixed with "client:"
	Origin string `json:"origin"`
	Track  Track  `json:"track"`
}

type Track struct {
	Title   string   `json:"title"`
	Artists []string `json:"artists"`
	Album   Album    `json:"album"`
	Length  int64    `json:"length"`
}

type Album struct {
	Title   string   `json:"albumtitle"`
	Artists []string `json:"artists"`
}

type Pagination struct {
	Page     int    `json:"page"`
	PerPage  int    `json:"perpage"`
	NextPage string `json:"next_page"`
	PrevPage string `json:"prev_page"`
}
